﻿<AML>
 <Item type="Method" id="2074D8C828ED4239942C31B1823E000D" action="add">
  <comments>2018-01-31--MyoThet</comments>
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			sop_add_description_well_field 
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                -Getting Well,Description from sopsv_service.
                -Update Well,Desctription to sop_so_service.
                -Getting Well,Description,Part Number from sopsv_service_part.
                -Update Well,Desctription,part Number to sop_so_service_part.
                -Update Well Status in Sale Order.

            Hooks:
                Type:		ItemType : sop_sale_order
                Event:		Server Events ( onAfterAdd, onAfterUpdate )
                
            Revisions:
                Rev Date		Modified By			Description
                2018-01-31		MyoThet				Update Well Status
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "sop_add_description_well_field";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _id = this.getID();

                bool with_well = false; // 2018-01-31--MyoThet

                //service detail
                var sop_so_service = myInnovator.newItem("sop_so_service", "get");
                sop_so_service.setProperty("source_id", _id);
                sop_so_service = sop_so_service.apply();
                var _so_service_count = sop_so_service.getItemCount();

                for (var b = 0; b < _so_service_count; b++)
                {
                    var sop_so_service_item = sop_so_service.getItemByIndex(b);
                    var service_update_id = sop_so_service_item.getProperty("id");
                    var so_related_id = sop_so_service_item.getProperty("related_id");

                    var sopsv_service = myInnovator.newItem("sopsv_service", "get");
                    sopsv_service.setProperty("id", so_related_id);
                    sopsv_service = sopsv_service.apply();
                    var sopsv_service_count = sopsv_service.getItemCount();
                    if (sopsv_service_count > 0)
                    {
                        var sopsv_service_item = sopsv_service.getItemByIndex(0);
                        var sop_description = sopsv_service_item.getProperty("sop_description", "");
                        var sop_well = sopsv_service_item.getProperty("sop_well", "");

                        // 2018-01-31--MyoThet
                        if (sop_well != "")
                        {
                            with_well = true;
                        }

                        Item so_service_update = myInnovator.applySQL("Update innovator.[sop_so_service] set stk_description='" + sop_description + "', " +
                            "stk_well='" + sop_well + "' where id='" + service_update_id + "'");
                    }
                }
                //service detail
                var sop_so_service_part = myInnovator.newItem("sop_so_service_part", "get");
                sop_so_service_part.setProperty("source_id", _id);
                sop_so_service_part = sop_so_service_part.apply();
                var _so_service_part_count = sop_so_service_part.getItemCount();

                for (var b = 0; b < _so_service_part_count; b++)
                {
                    var sop_so_service_part_item = sop_so_service_part.getItemByIndex(b);
                    var service_part_update_id = sop_so_service_part_item.getProperty("id");
                    var so_part_related_id = sop_so_service_part_item.getProperty("related_id");

                    var sopsv_service_part = myInnovator.newItem("sopsv_service_part", "get");
                    sopsv_service_part.setProperty("id", so_part_related_id);
                    sopsv_service_part = sopsv_service_part.apply();
                    var sopsv_service_part_count = sopsv_service_part.getItemCount();
                    if (sopsv_service_part_count > 0)
                    {
                        var sopsv_service_part_item = sopsv_service_part.getItemByIndex(0);
                        var sop_description = sopsv_service_part_item.getProperty("sop_description", "");
                        var sop_well = sopsv_service_part_item.getProperty("sop_well", "");

                        // 2018-01-31--MyoThet
                        if (sop_well != "")
                        {
                            with_well = true;
                        }

                        var sop_part_number = sopsv_service_part_item.getProperty("sop_part_number");

                        Item so_service_update = myInnovator.applySQL("Update innovator.[sop_so_service_part] set stk_description='" + sop_description + "', " +
                            "stk_well='" + sop_well + "',stk_part_number='" + sop_part_number + "' where id='" + service_part_update_id + "'");
                    }
                }

                // 2018-01-31--MyoThet
                if (with_well)
                {
                    StringBuilder sb_well_status = new StringBuilder("");
                    sb_well_status.Append(" UPDATE innovator.[SOP_SALE_ORDER]");
                    sb_well_status.Append(" SET sop_well_status = 'With Well'");
                    sb_well_status.Append(" WHERE ID = '" + _id + "'");

                    string qry_well_status = sb_well_status.ToString();

                    Item update_well_status = myInnovator.applySQL(qry_well_status);
                    if (update_well_status.isError())
                    {
                        return myInnovator.newError(update_well_status.getErrorDetail());
                    }
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>sop_add_description_well_field</name>
 </Item>
</AML>